Package org.apache.lucene.queries.spans

## Class FieldMaskingSpanQuery

- java.lang.Object
- - org.apache.lucene.search.Query
  - - org.apache.lucene.queries.spans.SpanQuery
    - - org.apache.lucene.queries.spans.FieldMaskingSpanQuery

-     public final class FieldMaskingSpanQuery
      extends SpanQuery

  Wrapper to allow `SpanQuery` objects participate in composite single-field SpanQueries by 'lying' about their search field. That is, the masked SpanQuery will function as normal, but `SpanQuery.getField()` simply hands back the value supplied in this class's constructor.

  This can be used to support Queries like `SpanNearQuery` or `SpanOrQuery` across different fields, which is not ordinarily permitted.

  This can be useful for denormalized relational data: for example, when indexing a document with conceptually many 'children':

        teacherid: 1
        studentfirstname: james
        studentsurname: jones

        teacherid: 2
        studenfirstname: james
        studentsurname: smith
        studentfirstname: sally
        studentsurname: jones

  a SpanNearQuery with a slop of 0 can be applied across two `SpanTermQuery` objects as follows:

          SpanQuery q1  = new SpanTermQuery(new Term("studentfirstname", "james"));
          SpanQuery q2  = new SpanTermQuery(new Term("studentsurname", "jones"));
          SpanQuery q2m = new FieldMaskingSpanQuery(q2, "studentfirstname");
          Query q = new SpanNearQuery(new SpanQuery[]{q1, q2m}, -1, false);

  to search for 'studentfirstname:james studentsurname:jones' and find teacherid 1 without matching teacherid 2 (which has a 'james' in position 0 and 'jones' in position 1).

  Note: as `getField()` returns the masked field, scoring will be done using the Similarity and collection statistics of the field name supplied, but with the term statistics of the real field. This may lead to exceptions, poor performance, and unexpected scoring behaviour.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FieldMaskingSpanQuery​(SpanQuery maskedQuery, String maskedField)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `SpanWeight` | `createWeight​(IndexSearcher searcher, ScoreMode scoreMode, float boost)` |
    `boolean` | `equals​(Object other)` |
    `String` | `getField()` | Returns the name of the field matched by this query.
    `SpanQuery` | `getMaskedQuery()` |
    `int` | `hashCode()` |
    `Query` | `rewrite​(IndexSearcher indexSearcher)` |
    `String` | `toString​(String field)` |
    `void` | `visit​(QueryVisitor visitor)` |

    - ### Methods inherited from class org.apache.lucene.queries.spans.SpanQuery

      `getTermStates, getTermStates`

    - ### Methods inherited from class org.apache.lucene.search.Query

      `classHash, rewrite, sameClassAs, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### FieldMaskingSpanQuery

          public FieldMaskingSpanQuery​(SpanQuery maskedQuery,
                                       String maskedField)

  - ### Method Detail

    - #### getField

          public String getField()

      Description copied from class: `SpanQuery`
      Returns the name of the field matched by this query.
      Specified by:
        `getField` in class `SpanQuery`

    - #### getMaskedQuery

          public SpanQuery getMaskedQuery()

    - #### createWeight

          public SpanWeight createWeight​(IndexSearcher searcher,
                                         ScoreMode scoreMode,
                                         float boost)
                                  throws IOException

      Specified by:
        `createWeight` in class `SpanQuery`
      Throws:
        `IOException`

    - #### rewrite

          public Query rewrite​(IndexSearcher indexSearcher)
                        throws IOException

      Overrides:
        `rewrite` in class `Query`
      Throws:
        `IOException`

    - #### visit

          public void visit​(QueryVisitor visitor)

      Specified by:
        `visit` in class `Query`

    - #### toString

          public String toString​(String field)

      Specified by:
        `toString` in class `Query`

    - #### equals

          public boolean equals​(Object other)

      Specified by:
        `equals` in class `Query`

    - #### hashCode

          public int hashCode()

      Specified by:
        `hashCode` in class `Query`